Package ghidra.trace.model

# Record Class Lifespan.Impl

java.lang.Object
java.lang.Record
ghidra.trace.model.Lifespan.Impl

Record Components:
  `lmin` - the minimum snap
  `lmax` - the maximum snap

All Implemented Interfaces:
  `Span<Long,Lifespan>`, `Lifespan`, `Comparable<Lifespan>`, `Iterable<Long>`

Enclosing interface:
  `Lifespan`

public static record Lifespan.Impl(long lmin, long lmax) extends Record implements Lifespan
A non-empty lifespan of snapshot keys

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from interface ghidra.trace.model.Lifespan

  `Lifespan.DefaultLifeSet, Lifespan.Domain, Lifespan.Empty, Lifespan.Impl, Lifespan.LifeSet, Lifespan.MutableLifeSet`

  ## Nested classes/interfaces inherited from interface generic.Span

  `Span.DefaultSpanMap<N,S extends Span<N,S>,V>, Span.DefaultSpanSet<N,S extends Span<N,S>>, Span.MutableSpanMap<N,S extends Span<N,S>,V>, Span.MutableSpanSet<N,S extends Span<N,S>>, Span.SpanMap<N,S extends Span<N,S>,V>, Span.SpanMapSetter<E,N,S extends Span<N,S>,V>, Span.SpanSet<N,S extends Span<N,S>>`

- ## Field Summary

  ### Fields inherited from interface ghidra.trace.model.Lifespan

  `ALL, DOMAIN, EMPTY`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Impl(long lmin, long lmax)`
  Creates an instance of a `Impl` record class.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `contains(long n)`
  `boolean`
  `contains(Long n)`
  Check if this span contains the given value
  `final boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `final int`
  `hashCode()`
  Returns a hash code value for this object.
  `Iterator<Long>`
  `iterator()`
  `long`
  `lmax()`
  Returns the value of the `lmax` record component.
  `long`
  `lmin()`
  Returns the value of the `lmin` record component.
  `Long`
  `max()`
  Get the upper endpoint
  `boolean`
  `maxIsFinite()`
  Check if the upper endpoint excludes the domain maximum
  `Long`
  `min()`
  Get the lower enpdoint
  `boolean`
  `minIsFinite()`
  Check if the lower endpoint excludes the domain minimum
  `String`
  `toString()`
  Returns a string representation of this record class.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface java.lang.Iterable

  `forEach, spliterator`

  ### Methods inherited from interface ghidra.trace.model.Lifespan

  `domain, withMax, withMin`

  ### Methods inherited from interface generic.Span

  `bound, compareTo, encloses, intersect, intersects, isEmpty, subtract, toString`

- ## Constructor Details

  - ### Impl

    public Impl(long lmin, long lmax)
    Creates an instance of a `Impl` record class.
    Parameters:
      `lmin` - the value for the `lmin` record component
      `lmax` - the value for the `lmax` record component

- ## Method Details

  - ### toString

    public String toString()
    Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.
    Specified by:
      `toString` in class `Record`
    Returns:
      a string representation of this object

  - ### contains

    public boolean contains(long n)
    Specified by:
      `contains` in interface `Lifespan`

  - ### contains

    public boolean contains(Long n)
    Description copied from interface: `Span`
    Check if this span contains the given value
    Specified by:
      `contains` in interface `Span<Long,Lifespan>`
    Parameters:
      `n` - the value
    Returns:
      true if n is contained in this span

  - ### min

    public Long min()
    Description copied from interface: `Span`
    Get the lower enpdoint
    Specified by:
      `min` in interface `Span<Long,Lifespan>`
    Returns:
      the lower endpoint
    See Also:
      - `Span.isEmpty()`

  - ### max

    public Long max()
    Description copied from interface: `Span`
    Get the upper endpoint
    Specified by:
      `max` in interface `Span<Long,Lifespan>`
    Returns:
      the upper endpoint
    See Also:
      - `Span.isEmpty()`

  - ### minIsFinite

    public boolean minIsFinite()
    Description copied from interface: `Span`
    Check if the lower endpoint excludes the domain minimum
    Specified by:
      `minIsFinite` in interface `Span<Long,Lifespan>`
    Returns:
      true if min is not the domain min

  - ### maxIsFinite

    public boolean maxIsFinite()
    Description copied from interface: `Span`
    Check if the upper endpoint excludes the domain maximum
    Specified by:
      `maxIsFinite` in interface `Span<Long,Lifespan>`
    Returns:
      true if max is not the domain max

  - ### iterator

    public Iterator<Long> iterator()
    Specified by:
      `iterator` in interface `Iterable<Long>`

  - ### hashCode

    public final int hashCode()
    Returns a hash code value for this object. The value is derived from the hash code of each of the record components.
    Specified by:
      `hashCode` in class `Record`
    Returns:
      a hash code value for this object

  - ### equals

    public final boolean equals(Object o)
    Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. All components in this record class are compared with '=='.
    Specified by:
      `equals` in class `Record`
    Parameters:
      `o` - the object with which to compare
    Returns:
      `true` if this object is the same as the `o` argument; `false` otherwise.

  - ### lmin

    public long lmin()
    Returns the value of the `lmin` record component.
    Specified by:
      `lmin` in interface `Lifespan`
    Returns:
      the value of the `lmin` record component

  - ### lmax

    public long lmax()
    Returns the value of the `lmax` record component.
    Specified by:
      `lmax` in interface `Lifespan`
    Returns:
      the value of the `lmax` record component